Index: nparser.php
===================================================================
--- nparser.php	(revision 12948)
+++ nparser.php	(working copy)
@@ -27,6 +27,13 @@
 	var $Buffers = array();
 	var $InsideComment = false;
 
+	/**
+	 * Parse tags inside HTML comments
+	 *
+	 * @var bool
+	 */
+	var $SkipComments = true;
+
 	var $Params = array();
 	var $ParamsStack = array();
 	var $ParamsLevel = 0;
@@ -131,7 +138,7 @@
 
 			// the idea is to count number of comment openings and closings before current tag
 			// if the numbers do not match we inverse the status of InsideComment
-			if (substr_count($tag_data[1][0], '<!--') != substr_count($tag_data[1][0], '-->')) {
+			if ($this->SkipComments && (substr_count($tag_data[1][0], '<!--') != substr_count($tag_data[1][0], '-->'))) {
 				$this->InsideComment = !$this->InsideComment;
 			}
 
Index: ntags.php
===================================================================
--- ntags.php	(revision 12948)
+++ ntags.php	(working copy)
@@ -99,14 +99,18 @@
 
 class _Tag_Comment extends _BlockTag {
 
-	function PassThrough(&$tag)
+	function Open($tag)
 	{
-		$tag['processed'] = true;
+		$this->Parser->SkipComments = false;
+
+		return '';
 	}
 
 	function Close($tag)
 	{
-		return '';
+		$this->Parser->SkipComments = true;
+
+		return $this->Parser->Buffers[$this->Parser->Level];
 	}
 }
 
